import os
import sys
import string
import commands
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox
from chimera import replyobj
import chimera
import airsIO


try:
	import chimera
	from chimera.baseDialog import ModelessDialog
	import VolumeViewer
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window
	
class pseudoatoms(ModelessDialog):
	name = "pseudoatoms ui"
	buttons = ("Apply","Close")
	title = "SSEhunter"
	direman=os.environ["HOME"]
	hellp = os.path.join(os.environ['EMANDIR'],"doc/AIRS/pseudoatoms-help.htm")
	help = hellp
	
	def targetSelector(self):
		self.targetnames=airsIO.getVolumeNames()   
		self.targetButton.setitems(self.targetnames)		
	
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(self.frame0, relief=GROOVE)
		self.frame1.grid(column=0,row=0, sticky=EW)
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=0,row=1, sticky=EW)
		
		Label(self.frame1, text='MRC file:   ').grid(row=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame1,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		
		Label(self.frame2, text='angstrom/pixel:').grid(row=0, column=0, sticky=W)
		Label(self.frame2, text='resolution:    ').grid(row=1, column=0, sticky=W)
		Label(self.frame2, text='threshold:     ').grid(row=2, column=0, sticky=W)

		self.apix = Entry(self.frame2, width = 6)
		self.apix.grid(row=0, column=1, sticky=W)
		self.res = Entry(self.frame2, width = 6)
		self.res.grid(row=1, column=1, sticky=W)		
		self.thresh = Entry(self.frame2, width = 6)
		self.thresh.grid(row=2, column=1, sticky=W)		

		self.mapOri=IntVar()
		s = Checkbutton(self.frame2, text="Density map origin", variable=self.mapOri).grid(row=3, column=0, sticky=W)
		
	def Apply(self):
		target=airsIO.cleanFileName(str(self.target.get()))
		targetPath=airsIO.getPath(target)
		justPath=targetPath.split(target)[0]
		t=os.path.splitext(target)
		targetPRE=str(t[0])

		apix=float(self.apix.get())
		thresh=float(self.thresh.get())
		res=float(self.res.get())
		
		mapinfo=airsIO.getMapInfo(target)
		mapSize=mapinfo[0][0]
		mapOrigin=mapinfo[1]  
		
		logfile="%slog-pseudoatoms-%s.txt"%(justPath, targetPRE)

		outfile="%spseudoatoms-%s.pdb"%(justPath, targetPRE)
		cmd1="pseudoatom.py %s %s %f %f %f > %s"%(targetPath,outfile,apix,res,thresh,logfile)
		print cmd1
		os.system(cmd1) #outfile written here

		if self.mapOri.get()==1:
			Ox=mapOrigin[0]
			Oy=mapOrigin[1]
			Oz=mapOrigin[2]			
			cmdt="procpdb.py %s %s trans=%f,%f,%f"%(outfile,outfile,Ox,Oy,Oz)
			os.system(cmdt)

		chimera.openModels.open(outfile) #file must exist for this chimera function

try:
	chimera.dialogs.register(pseudoatoms.name, pseudoatoms)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = pseudoatoms()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.targetSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)			
